"use strict";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _testUtils = require("../../../testUtils");

var _ = require("..");

var _2 = _interopRequireDefault(_);

var testDeclarationBangBefore = (0, _testUtils.ruleTester)(_2["default"], _.ruleName);

testDeclarationBangBefore({ before: "always" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink !important; }", "space only before");
  tr.ok("a { color: pink ! important; }", "space before and after");
  tr.ok("a { color: pink !\nimportant; }", "space before and newline after");

  tr.notOk("a { color: pink  !important; }", "two spaces before", _.messages.expectedBefore());
  tr.notOk("a { color: pink!important; }", "no space before", _.messages.expectedBefore());
  tr.notOk("a { color: pink\n!important; }", "newline before", _.messages.expectedBefore());
});

testDeclarationBangBefore({ before: "never" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink!important; }", "no spaces");
  tr.ok("a { color: pink! important; }", "no space before and after");
  tr.ok("a { color: pink!\nimportant; }", "no space before and newline after");

  tr.notOk("a { color: pink !important; }", "space before", _.messages.rejectedBefore());
  tr.notOk("a { color: pink\n!important; }", "newline before", _.messages.rejectedBefore());
});

testDeclarationBangBefore({ after: "always" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink! important; }", "space only after");
  tr.ok("a { color: pink ! important; }", "space before and after");
  tr.ok("a { color: pink\n! important; }", "newline before and space after");

  tr.notOk("a { color: pink!important; }", "no space after", _.messages.expectedAfter());
  tr.notOk("a { color: pink!  important; }", "two spaces after", _.messages.expectedAfter());
  tr.notOk("a { color: pink!\nimportant; }", "newline after", _.messages.expectedAfter());
});

testDeclarationBangBefore({ after: "never" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink!important; }", "no space before or after");
  tr.ok("a { color: pink !important; }", "space before and none after");
  tr.ok("a { color: pink\n!important; }", "newline before and none after");

  tr.notOk("a { color: pink! important; }", "space after", _.messages.rejectedAfter());
  tr.notOk("a { color: pink!\nimportant; }", "newline after", _.messages.rejectedAfter());
});

testDeclarationBangBefore({ before: "always", after: "never" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink !important; }", "space only before");

  tr.notOk("a { color: pink ! important; }", "space before and after", _.messages.rejectedAfter());
  tr.notOk("a { color: pink  !important; }", "two spaces before", _.messages.expectedBefore());
  tr.notOk("a { color: pink!important; }", "no space before", _.messages.expectedBefore());
  tr.notOk("a { color: pink\n!important; }", "newline before", _.messages.expectedBefore());
});

testDeclarationBangBefore({ before: "never", after: "always" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink! important; }", "space only after");

  tr.notOk("a { color: pink ! important; }", "space before and after", _.messages.rejectedBefore());
  tr.notOk("a { color: pink!  important; }", "two spaces after", _.messages.expectedAfter());
  tr.notOk("a { color: pink!important; }", "no space after", _.messages.expectedAfter());
  tr.notOk("a { color: pink!\nimportant; }", "newline before", _.messages.expectedAfter());
});

testDeclarationBangBefore({ before: "always", after: "always" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink ! important; }", "space before and after");

  tr.notOk("a { color: pink! important; }", "no space before and one after", _.messages.expectedBefore());
  tr.notOk("a { color: pink  ! important; }", "two spaces before and one after", _.messages.expectedBefore());
  tr.notOk("a { color: pink! important; }", "no space before and one after", _.messages.expectedBefore());
  tr.notOk("a { color: pink\n! important; }", "newline before and one after", _.messages.expectedBefore());
  tr.notOk("a { color: pink !important; }", "one space before and none after", _.messages.expectedAfter());
  tr.notOk("a { color: pink !  important; }", "one before and two after", _.messages.expectedAfter());
  tr.notOk("a { color: pink !important; }", "one space before and none after", _.messages.expectedAfter());
  tr.notOk("a { color: pink !\nimportant; }", "one space before and newline after", _.messages.expectedAfter());
});

testDeclarationBangBefore({ before: "never", after: "never" }, function (tr) {
  tr.ok("a { color: pink; }", "no !important");
  tr.ok("a { color: pink!important; }", "no spaces before or after");

  tr.notOk("a { color: pink! important; }", "no space before and one after", _.messages.rejectedAfter());
  tr.notOk("a { color: pink !important; }", "one space before and none after", _.messages.rejectedBefore());
  tr.notOk("a { color: pink\n!important; }", "newline before and no space after", _.messages.rejectedBefore());
  tr.notOk("a { color: pink!\nimportant; }", "no space before and newline after", _.messages.rejectedAfter());
});